/* 
 * ON PUBLIC DOMAIN
 * Author         : Nitish Dash
 * Name           : LDR Light Level Display on 16X2 LCD
 * Created        : 12/27/2014
 * Webpage        : http://goo.gl/Er9y4l
 * Author Email   : nitishdash95@gmail.com
 * Author Website : http://www.nitishdash.com/
 **** DONOT COPY AND PLAGIARATE WITHOUT THE AUTHOR'S PERMISSIONS ****
 */
#include <Wire.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(10, 9, 8, 7, 6, 5);


#include <SoftwareSerialWithHalfDuplex.h>
SoftwareSerialWithHalfDuplex mySerial(12, 11); // RX, TX

#define node_id '1'



int sensors[5];
int sensorPins[5] ={A0,A1,A2,A3,A6};


void setup() { //initialise for at least 2s

// set the data rate for the SoftwareSerial port
  mySerial.begin(4800);


  Wire.begin(); // join i2c bus (address optional for master)

  Serial.begin(115200);

  lcd.begin(16, 2);
  lcd.print("INITIALISING");
  delay(500);
  lcd.print(".");
  delay(500);
  lcd.print(".");  
  delay(500);
  lcd.print(".");
  delay(500);
  lcd.print(".");  
  delay(500);



  lcd.clear();
  lcd.print("req. node 2");
  lcd.setCursor(0, 1);
  //send character '1' aka the ID of the first node
  mySerial.print('2'); // hey led board
  mySerial.print('1'); // please turn on led number 1
 delay (500);
  mySerial.print('2'); // hey led board
  mySerial.print('3');
 delay (500);
  
 
  
  // wait for first node to respond
  
  while (!mySerial.available()) {
    ;
  }
  char chr = mySerial.read(); 
  lcd.print(chr);
delay(1000); 



}

void loop()

{

  int sensAvg=0;
  int active=0;
  for (int i=0;i<5;i++) {
    sensors[i]=analogRead(sensorPins[i]);
    sensAvg+=sensors[i];
    delay(5);
    Serial.print(i);
    Serial.print(":");
    Serial.print(sensors[i]);
    Serial.print(";");
  }
  sensAvg/=5;
    Serial.print("Sensavg:");
    Serial.print(sensAvg);
    Serial.print(";");
  
  int dev=0;
  for (int i=0;i<5;i++) {
    int tmp = abs(sensors[i]-sensAvg);
    if (tmp>dev) {
      active=i;
      dev=tmp;
    }
/*
 * if the dev (deviation) is less than 100,
 * we can assume that no activity is taking place on the neck
 * 
 * make active -1
 * 
 */
 // ...
    
    Serial.print(i);
    Serial.print(":");
    Serial.print(tmp);
    Serial.print("; ");
 
  }
  Serial.print(" Active: ");
  Serial.println(active);

  byte err=-1;
  if (active >= -1 ) { // if these is an active input
    err = setWiper(map(active, 0, 4, 512, 0));
    mySerial.print('2'); // hey led board
    mySerial.print(active+1); // please turn the 'active' led on
  } else {               // if not, all the inputs are below the treshold (so no inputs active)
    err = setWiper(0);
 //...  set led to nightrider routine (runs once)
  }

  
   
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Active:");
  lcd.print(active);
  lcd.print(" ");
  lcd.print(err);
  lcd.setCursor(0, 1);
  lcd.print(sensAvg);
  lcd.print(" ");
  
 delay(100); 

}

byte setWiper (int wiper) {

byte err=0;
 Wire.beginTransmission(0x2F); // transmit to device #47 (0x2F)
 // device address is specified in datasheet
 byte tmp = (wiper >> 8) & 0xFF;
 Wire.write(tmp);            // sends memory, command and D8 byte
 tmp = wiper & 0xFF;
 Wire.write(tmp);             // sends D7-D0 value byte
 
 err = Wire.endTransmission();     // stop transmitting
 return err;
}






